Index: protocols/msn/msn.c
===================================================================
--- protocols/msn/msn.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/msn/msn.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -30,5 +30,4 @@
 int msn_chat_id;
 GSList *msn_connections;
-GSList *msn_switchboards;
 
 static char *set_eval_display_name(set_t *set, char *value);
@@ -41,5 +40,5 @@
 	s->flags |= SET_NOSAVE | ACC_SET_ONLINE_ONLY;
 
-	s = set_add(&acc->set, "server", MSN_NS_HOST, set_eval_account, acc);
+	s = set_add(&acc->set, "server", NULL, set_eval_account, acc);
 	s->flags |= SET_NOSAVE | ACC_SET_OFFLINE_ONLY;
 
@@ -48,5 +47,4 @@
 
 	set_add(&acc->set, "mail_notifications", "false", set_eval_bool, acc);
-	set_add(&acc->set, "switchboard_keepalives", "false", set_eval_bool, acc);
 
 	acc->flags |= ACC_FLAG_AWAY_MESSAGE | ACC_FLAG_STATUS_MESSAGE |
@@ -58,7 +56,12 @@
 	struct im_connection *ic = imcb_new(acc);
 	struct msn_data *md = g_new0(struct msn_data, 1);
+	char *server = set_getstr(&ic->acc->set, "server");
 
 	ic->proto_data = md;
 	ic->flags |= OPT_PONGS | OPT_PONGED;
+
+	if (!server) {
+		server = "geo.gateway.messenger.live.com";
+	}
 
 	if (strchr(acc->user, '@') == NULL) {
@@ -71,11 +74,11 @@
 	md->away_state = msn_away_state_list;
 	md->domaintree = g_tree_new(msn_domaintree_cmp);
-	md->ns->fd = -1;
+	md->fd = -1;
+	md->is_http = TRUE;
 
 	msn_connections = g_slist_prepend(msn_connections, ic);
 
 	imcb_log(ic, "Connecting");
-	msn_ns_connect(ic, md->ns,
-	               set_getstr(&ic->acc->set, "server"),
+	msn_ns_connect(ic, server,
 	               set_getint(&ic->acc->set, "port"));
 }
@@ -88,17 +91,6 @@
 
 	if (md) {
-		/** Disabling MSN ft support for now.
-		while( md->filetransfers ) {
-		        imcb_file_canceled( md->filetransfers->data, "Closing connection" );
-		}
-		*/
-
-		msn_ns_close(md->ns);
-
-		while (md->switchboards) {
-			msn_sb_destroy(md->switchboards->data);
-		}
-
-		msn_msgq_purge(ic, &md->msgq);
+		msn_ns_close(md);
+
 		msn_soapq_flush(ic, FALSE);
 
@@ -112,8 +104,8 @@
 		while (md->groups) {
 			struct msn_group *mg = md->groups->data;
+			md->groups = g_slist_remove(md->groups, mg);
 			g_free(mg->id);
 			g_free(mg->name);
 			g_free(mg);
-			md->groups = g_slist_remove(md->groups, mg);
 		}
 
@@ -127,8 +119,8 @@
 		while (md->grpq) {
 			struct msn_groupadd *ga = md->grpq->data;
+			md->grpq = g_slist_remove(md->grpq, ga);
 			g_free(ga->group);
 			g_free(ga->who);
 			g_free(ga);
-			md->grpq = g_slist_remove(md->grpq, ga);
 		}
 
@@ -152,27 +144,13 @@
 {
 	struct bee_user *bu = bee_user_by_handle(ic->bee, ic, who);
-	struct msn_buddy_data *bd = bu ? bu->data : NULL;
-	struct msn_switchboard *sb;
 
 #ifdef DEBUG
 	if (strcmp(who, "raw") == 0) {
 		msn_ns_write(ic, -1, "%s\r\n", message);
-	} else
+		return 0;
+	}
 #endif
-	if (bd && bd->flags & MSN_BUDDY_FED) {
-		msn_ns_sendmessage(ic, bu, message);
-	} else if ((sb = msn_sb_by_handle(ic, who))) {
-		return(msn_sb_sendmessage(sb, message));
-	} else {
-		struct msn_message *m;
-
-		/* Create a message. We have to arrange a usable switchboard, and send the message later. */
-		m = g_new0(struct msn_message, 1);
-		m->who = g_strdup(who);
-		m->text = g_strdup(message);
-
-		return msn_sb_write_msg(ic, m);
-	}
-
+
+	msn_ns_sendmessage(ic, bu, message);
 	return(0);
 }
@@ -196,6 +174,6 @@
 static void msn_set_away(struct im_connection *ic, char *state, char *message)
 {
-	char *uux;
 	struct msn_data *md = ic->proto_data;
+	char *nick, *psm, *idle, *statecode, *body, *buf;
 
 	if (state == NULL) {
@@ -205,30 +183,21 @@
 	}
 
-	if (!msn_ns_write(ic, -1, "CHG %d %s %d:%02d\r\n", ++md->trId, md->away_state->code, MSN_CAP1, MSN_CAP2)) {
-		return;
-	}
-
-	uux = g_markup_printf_escaped("<EndpointData><Capabilities>%d:%02d"
-	                              "</Capabilities></EndpointData>",
-	                              MSN_CAP1, MSN_CAP2);
-	msn_ns_write(ic, -1, "UUX %d %zd\r\n%s", ++md->trId, strlen(uux), uux);
-	g_free(uux);
-
-	uux = g_markup_printf_escaped("<PrivateEndpointData><EpName>%s</EpName>"
-	                              "<Idle>%s</Idle><ClientType>%d</ClientType>"
-	                              "<State>%s</State></PrivateEndpointData>",
-	                              md->uuid,
-	                              strcmp(md->away_state->code, "IDL") ? "false" : "true",
-	                              1,  /* ? */
-	                              md->away_state->code);
-	msn_ns_write(ic, -1, "UUX %d %zd\r\n%s", ++md->trId, strlen(uux), uux);
-	g_free(uux);
-
-	uux = g_markup_printf_escaped("<Data><DDP></DDP><PSM>%s</PSM>"
-	                              "<CurrentMedia></CurrentMedia>"
-	                              "<MachineGuid>%s</MachineGuid></Data>",
-	                              message ? message : "", md->uuid);
-	msn_ns_write(ic, -1, "UUX %d %zd\r\n%s", ++md->trId, strlen(uux), uux);
-	g_free(uux);
+	statecode = (char *) md->away_state->code;
+	nick = set_getstr(&ic->acc->set, "display_name");
+	psm = message ? message : "";
+	idle = (strcmp(statecode, "IDL") == 0) ? "false" : "true";
+
+	body = g_markup_printf_escaped(MSN_PUT_USER_BODY,
+		nick, psm, psm, md->uuid, statecode, md->uuid, idle, statecode,
+		MSN_CAP1, MSN_CAP2, MSN_CAP1, MSN_CAP2
+	);
+
+	buf = g_strdup_printf(MSN_PUT_HEADERS, ic->acc->user, ic->acc->user, md->uuid,
+		"/user", "application/user+xml",
+		strlen(body), body);
+	msn_ns_write(ic, -1, "PUT %d %zd\r\n%s", ++md->trId, strlen(buf), buf);
+
+	g_free(buf);
+	g_free(body);
 }
 
@@ -256,51 +225,22 @@
 static void msn_chat_msg(struct groupchat *c, char *message, int flags)
 {
-	struct msn_switchboard *sb = msn_sb_by_chat(c);
-
-	if (sb) {
-		msn_sb_sendmessage(sb, message);
-	}
-	/* FIXME: Error handling (although this can't happen unless something's
-	   already severely broken) disappeared here! */
+	/* TODO: groupchats*/
 }
 
 static void msn_chat_invite(struct groupchat *c, char *who, char *message)
 {
-	struct msn_switchboard *sb = msn_sb_by_chat(c);
-
-	if (sb) {
-		msn_sb_write(sb, "CAL %d %s\r\n", ++sb->trId, who);
-	}
+	/* TODO: groupchats*/
 }
 
 static void msn_chat_leave(struct groupchat *c)
 {
-	struct msn_switchboard *sb = msn_sb_by_chat(c);
-
-	if (sb) {
-		msn_sb_write(sb, "OUT\r\n");
-	}
+	/* TODO: groupchats*/
 }
 
 static struct groupchat *msn_chat_with(struct im_connection *ic, char *who)
 {
-	struct msn_switchboard *sb;
+	/* TODO: groupchats*/
 	struct groupchat *c = imcb_chat_new(ic, who);
-
-	if ((sb = msn_sb_by_handle(ic, who))) {
-		debug("Converting existing switchboard to %s to a groupchat", who);
-		return msn_sb_to_chat(sb);
-	} else {
-		struct msn_message *m;
-
-		/* Create a magic message. This is quite hackish, but who cares? :-P */
-		m = g_new0(struct msn_message, 1);
-		m->who = g_strdup(who);
-		m->text = g_strdup(GROUPCHAT_SWITCHBOARD_MESSAGE);
-
-		msn_sb_write_msg(ic, m);
-
-		return c;
-	}
+	return c;
 }
 
@@ -322,12 +262,5 @@
 static void msn_add_deny(struct im_connection *ic, char *who)
 {
-	struct msn_switchboard *sb;
-
 	msn_buddy_list_add(ic, MSN_BUDDY_BL, who, who, NULL);
-
-	/* If there's still a conversation with this person, close it. */
-	if ((sb = msn_sb_by_handle(ic, who))) {
-		msn_sb_destroy(sb);
-	}
 }
 
@@ -462,6 +395,4 @@
 	ret->buddy_action = msn_buddy_action;
 
-	//ret->transfer_request = msn_ftp_transfer_request;
-
 	register_protocol(ret);
 }
Index: protocols/msn/msn.h
===================================================================
--- protocols/msn/msn.h	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/msn/msn.h	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -32,5 +32,4 @@
 #define NUDGE_MESSAGE "\r\r\rSHAKE THAT THING\r\r\r"
 #define GROUPCHAT_SWITCHBOARD_MESSAGE "\r\r\rME WANT TALK TO MANY PEOPLE\r\r\r"
-#define SB_KEEPALIVE_MESSAGE "\r\r\rDONT HANG UP ON ME!\r\r\r"
 
 #ifdef DEBUG_MSN
@@ -60,5 +59,5 @@
 #define MSNP11_PROD_KEY "C1BX{V4W}Q3*10SM"
 #define MSNP11_PROD_ID  "PROD0120PW!CCV9@"
-#define MSNP_VER        "MSNP18"
+#define MSNP_VER        "MSNP21"
 #define MSNP_BUILD      "14.0.8117.416"
 
@@ -68,9 +67,39 @@
 #define MSN_CAP2        0x0000
 
-#define MSN_MESSAGE_HEADERS "MIME-Version: 1.0\r\n" \
+#define MSN_BASE_HEADERS \
+	"Routing: 1.0\r\n" \
+	"To: 1:%s\r\n" \
+	"From: 1:%s;epid={%s}\r\n" \
+	"\r\n" \
+	"Reliability: 1.0\r\n" \
+	"\r\n"
+
+#define MSN_MESSAGE_HEADERS MSN_BASE_HEADERS \
+	"Messaging: 2.0\r\n" \
+	"Message-Type: Text\r\n" \
+	"Content-Length: %zd\r\n" \
 	"Content-Type: text/plain; charset=UTF-8\r\n" \
-	"User-Agent: BitlBee " BITLBEE_VERSION "\r\n" \
-	"X-MMS-IM-Format: FN=MS%20Shell%20Dlg; EF=; CO=0; CS=0; PF=0\r\n" \
-	"\r\n"
+	"X-MMS-IM-Format: FN=Segoe%%20UI; EF=; CO=0; CS=0; PF=0\r\n" \
+	"\r\n" \
+	"%s"
+
+#define MSN_PUT_HEADERS MSN_BASE_HEADERS \
+	"Publication: 1.0\r\n" \
+	"Uri: %s\r\n" \
+	"Content-Type: %s\r\n" \
+	"Content-Length: %zd\r\n" \
+	"\r\n" \
+	"%s"
+
+#define MSN_PUT_USER_BODY \
+	"<user>" \
+	"<s n=\"PE\"><UserTileLocation></UserTileLocation><FriendlyName>%s</FriendlyName><PSM>%s</PSM><DDP></DDP>" \
+	"<Scene></Scene><ASN></ASN><ColorScheme>-3</ColorScheme><BDG></BDG><RUM>%s</RUM><RUL></RUL><RLT>0</RLT>" \
+	"<RID></RID><SUL></SUL><MachineGuid>%s</MachineGuid></s>" \
+	"<s n=\"IM\"><Status>%s</Status><CurrentMedia></CurrentMedia></s>" \
+	"<sep n=\"PD\"><ClientType>1</ClientType><EpName>%s</EpName><Idle>%s</Idle><State>%s</State></sep>" \
+	"<sep n=\"PE\"><VER>BitlBee:" BITLBEE_VERSION "</VER><TYP>1</TYP><Capabilities>%d:%d</Capabilities></sep>" \
+	"<sep n=\"IM\"><Capabilities>%d:%d</Capabilities></sep>" \
+	"</user>"
 
 #define MSN_TYPING_HEADERS "MIME-Version: 1.0\r\n" \
@@ -84,8 +113,4 @@
 	"ID: 1\r\n" \
 	"\r\n"
-
-#define MSN_SB_KEEPALIVE_HEADERS "MIME-Version: 1.0\r\n" \
-	"Content-Type: text/x-ping\r\n" \
-	"\r\n\r\n"
 
 #define PROFILE_URL "http://members.msn.com/"
@@ -99,5 +124,27 @@
 } msn_flags_t;
 
-struct msn_handler_data {
+struct msn_gw {
+	char *last_host;
+	int port;
+	gboolean ssl;
+
+	char *session_id;
+
+	GByteArray *in;
+	GByteArray *out;
+
+	int poll_timeout;
+
+	b_event_handler callback;
+
+	struct im_connection *ic;
+	struct msn_data *md;
+
+	gboolean open;
+	gboolean waiting;
+	gboolean polling;
+};
+
+struct msn_data {
 	int fd, inpa;
 	int rxlen;
@@ -107,15 +154,6 @@
 	char *cmd_text;
 
-	/* Either ic or sb */
-	gpointer data;
-
-	int (*exec_command) (struct msn_handler_data *handler, char **cmd, int count);
-	int (*exec_message) (struct msn_handler_data *handler, char *msg, int msglen, char **cmd, int count);
-};
-
-struct msn_data {
 	struct im_connection *ic;
 
-	struct msn_handler_data ns[1];
 	msn_flags_t flags;
 
@@ -126,7 +164,4 @@
 
 	GSList *msgq, *grpq, *soapq;
-	GSList *switchboards;
-	int sb_failures;
-	time_t first_sb_failure;
 
 	const struct msn_away_state *away_state;
@@ -139,24 +174,7 @@
 	GTree *domaintree;
 	int adl_todo;
-};
-
-struct msn_switchboard {
-	struct im_connection *ic;
-
-	/* The following two are also in the handler. TODO: Clean up. */
-	int fd;
-	gint inp;
-	struct msn_handler_data *handler;
-	gint keepalive;
-
-	int trId;
-	int ready;
-
-	int session;
-	char *key;
-
-	GSList *msgq;
-	char *who;
-	struct groupchat *chat;
+
+	gboolean is_http;
+	struct msn_gw *gw;
 };
 
@@ -205,6 +223,4 @@
 #define STATUS_FATAL            1
 #define STATUS_SB_FATAL         2
-#define STATUS_SB_IM_SPARE      4       /* Make one-to-one conversation switchboard available again, invite failed. */
-#define STATUS_SB_CHAT_SPARE    8       /* Same, but also for groupchats (not used yet). */
 
 extern int msn_chat_id;
@@ -218,15 +234,15 @@
    before doing *anything* else. */
 extern GSList *msn_connections;
-extern GSList *msn_switchboards;
 
 /* ns.c */
 int msn_ns_write(struct im_connection *ic, int fd, const char *fmt, ...) G_GNUC_PRINTF(3, 4);
-gboolean msn_ns_connect(struct im_connection *ic, struct msn_handler_data *handler, const char *host, int port);
-void msn_ns_close(struct msn_handler_data *handler);
+gboolean msn_ns_connect(struct im_connection *ic, const char *host, int port);
+void msn_ns_close(struct msn_data *handler);
 void msn_auth_got_passport_token(struct im_connection *ic, const char *token, const char *error);
 void msn_auth_got_contact_list(struct im_connection *ic);
 int msn_ns_finish_login(struct im_connection *ic);
 int msn_ns_sendmessage(struct im_connection *ic, struct bee_user *bu, const char *text);
-void msn_ns_oim_send_queue(struct im_connection *ic, GSList **msgq);
+int msn_ns_command(struct msn_data *md, char **cmd, int num_parts);
+int msn_ns_message(struct msn_data *md, char *msg, int msglen, char **cmd, int num_parts);
 
 /* msn_util.c */
@@ -235,7 +251,6 @@
 int msn_buddy_list_remove(struct im_connection *ic, msn_buddy_flags_t list, const char *who, const char *group);
 void msn_buddy_ask(bee_user_t *bu);
-char **msn_linesplit(char *line);
-int msn_handler(struct msn_handler_data *h);
-void msn_msgq_purge(struct im_connection *ic, GSList **list);
+void msn_queue_feed(struct msn_data *h, char *bytes, int st);
+int msn_handler(struct msn_data *h);
 char *msn_p11_challenge(char *challenge);
 gint msn_domaintree_cmp(gconstpointer a_, gconstpointer b_);
@@ -251,17 +266,10 @@
 const struct msn_status_code *msn_status_by_number(int number);
 
-/* sb.c */
-int msn_sb_write(struct msn_switchboard *sb, const char *fmt, ...) G_GNUC_PRINTF(2, 3);;
-struct msn_switchboard *msn_sb_create(struct im_connection *ic, char *host, int port, char *key, int session);
-struct msn_switchboard *msn_sb_by_handle(struct im_connection *ic, const char *handle);
-struct msn_switchboard *msn_sb_by_chat(struct groupchat *c);
-struct msn_switchboard *msn_sb_spare(struct im_connection *ic);
-int msn_sb_sendmessage(struct msn_switchboard *sb, char *text);
-struct groupchat *msn_sb_to_chat(struct msn_switchboard *sb);
-void msn_sb_destroy(struct msn_switchboard *sb);
-gboolean msn_sb_connected(gpointer data, gint source, b_input_condition cond);
-int msn_sb_write_msg(struct im_connection *ic, struct msn_message *m);
-void msn_sb_start_keepalives(struct msn_switchboard *sb, gboolean initial);
-void msn_sb_stop_keepalives(struct msn_switchboard *sb);
+/* gw.c */
+struct msn_gw *msn_gw_new(struct im_connection *ic);
+void msn_gw_free(struct msn_gw *gw);
+void msn_gw_open(struct msn_gw *gw);
+ssize_t msn_gw_read(struct msn_gw *gw, char **buf);
+void msn_gw_write(struct msn_gw *gw, char *buf, size_t len);
 
 #endif //_MSN_H
Index: protocols/msn/msn_util.c
===================================================================
--- protocols/msn/msn_util.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/msn/msn_util.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -55,46 +55,4 @@
 
 	*groupid = '\0';
-#if 0
-	if (group) {
-		int i;
-		for (i = 0; i < md->groupcount; i++) {
-			if (g_strcasecmp(md->grouplist[i], group) == 0) {
-				g_snprintf(groupid, sizeof(groupid), " %d", i);
-				break;
-			}
-		}
-
-		if (*groupid == '\0') {
-			/* Have to create this group, it doesn't exist yet. */
-			struct msn_groupadd *ga;
-			GSList *l;
-
-			for (l = md->grpq; l; l = l->next) {
-				ga = l->data;
-				if (g_strcasecmp(ga->group, group) == 0) {
-					break;
-				}
-			}
-
-			ga = g_new0(struct msn_groupadd, 1);
-			ga->who = g_strdup(who);
-			ga->group = g_strdup(group);
-			md->grpq = g_slist_prepend(md->grpq, ga);
-
-			if (l == NULL) {
-				char groupname[strlen(group) + 1];
-				strcpy(groupname, group);
-				http_encode(groupname);
-				g_snprintf(buf, sizeof(buf), "ADG %d %s %d\r\n", ++md->trId, groupname, 0);
-				return msn_write(ic, buf, strlen(buf));
-			} else {
-				/* This can happen if the user's doing lots of adds to a
-				   new group at once; we're still waiting for the server
-				   to confirm group creation. */
-				return 1;
-			}
-		}
-	}
-#endif
 
 	if (!((bu = bee_user_by_handle(ic->bee, ic, who)) ||
@@ -132,15 +90,4 @@
 
 	*groupid = '\0';
-#if 0
-	if (group) {
-		int i;
-		for (i = 0; i < md->groupcount; i++) {
-			if (g_strcasecmp(md->grouplist[i], group) == 0) {
-				g_snprintf(groupid, sizeof(groupid), " %d", i);
-				break;
-			}
-		}
-	}
-#endif
 
 	if (!(bu = bee_user_by_handle(ic->bee, ic, who)) ||
@@ -174,11 +121,7 @@
 };
 
-static void msn_buddy_ask_yes(void *data)
+static void msn_buddy_ask_free(void *data)
 {
 	struct msn_buddy_ask_data *bla = data;
-
-	msn_buddy_list_add(bla->ic, MSN_BUDDY_AL, bla->handle, bla->realname, NULL);
-
-	imcb_ask_add(bla->ic, bla->handle, NULL);
 
 	g_free(bla->handle);
@@ -187,4 +130,15 @@
 }
 
+static void msn_buddy_ask_yes(void *data)
+{
+	struct msn_buddy_ask_data *bla = data;
+
+	msn_buddy_list_add(bla->ic, MSN_BUDDY_AL, bla->handle, bla->realname, NULL);
+
+	imcb_ask_add(bla->ic, bla->handle, NULL);
+
+	msn_buddy_ask_free(bla);
+}
+
 static void msn_buddy_ask_no(void *data)
 {
@@ -193,7 +147,5 @@
 	msn_buddy_list_add(bla->ic, MSN_BUDDY_BL, bla->handle, bla->realname, NULL);
 
-	g_free(bla->handle);
-	g_free(bla->realname);
-	g_free(bla);
+	msn_buddy_ask_free(bla);
 }
 
@@ -216,38 +168,19 @@
 	           "The user %s (%s) wants to add you to his/her buddy list.",
 	           bu->handle, bu->fullname);
-	imcb_ask(bu->ic, buf, bla, msn_buddy_ask_yes, msn_buddy_ask_no);
-}
-
-/* *NOT* thread-safe, but that's not a problem for now... */
-char **msn_linesplit(char *line)
-{
-	static char **ret = NULL;
-	static int size = 3;
-	int i, n = 0;
-
-	if (ret == NULL) {
-		ret = g_new0(char*, size);
-	}
-
-	for (i = 0; line[i] && line[i] == ' '; i++) {
-		;
-	}
-	if (line[i]) {
-		ret[n++] = line + i;
-		for (i++; line[i]; i++) {
-			if (line[i] == ' ') {
-				line[i] = 0;
-			} else if (line[i] != ' ' && !line[i - 1]) {
-				ret[n++] = line + i;
-			}
-
-			if (n >= size) {
-				ret = g_renew(char*, ret, size += 2);
-			}
-		}
-	}
-	ret[n] = NULL;
-
-	return(ret);
+
+	imcb_ask_with_free(bu->ic, buf, bla, msn_buddy_ask_yes, msn_buddy_ask_no, msn_buddy_ask_free);
+}
+
+void msn_queue_feed(struct msn_data *h, char *bytes, int st)
+{
+	h->rxq = g_renew(char, h->rxq, h->rxlen + st);
+	memcpy(h->rxq + h->rxlen, bytes, st);
+	h->rxlen += st;
+
+	if (getenv("BITLBEE_DEBUG")) {
+		fprintf(stderr, "\n\x1b[92m<<< ");
+		write(2, bytes , st);
+		fprintf(stderr, "\x1b[97m");
+	}
 }
 
@@ -260,20 +193,7 @@
                    1: OK */
 
-int msn_handler(struct msn_handler_data *h)
-{
-	int st;
-
-	h->rxq = g_renew(char, h->rxq, h->rxlen + 1024);
-	st = read(h->fd, h->rxq + h->rxlen, 1024);
-	h->rxlen += st;
-
-	if (st <= 0) {
-		return(-1);
-	}
-
-	if (getenv("BITLBEE_DEBUG")) {
-		write(2, "->C:", 4);
-		write(2, h->rxq + h->rxlen - st, st);
-	}
+int msn_handler(struct msn_data *h)
+{
+	int st = 1;
 
 	while (st) {
@@ -287,9 +207,10 @@
 
 					cmd_text = g_strndup(h->rxq, i);
-					cmd = msn_linesplit(cmd_text);
-					for (count = 0; cmd[count]; count++) {
-						;
-					}
-					st = h->exec_command(h, cmd, count);
+					cmd = g_strsplit_set(cmd_text, " ", -1);
+					count = g_strv_length(cmd);
+
+					st = msn_ns_command(h, cmd, count);
+
+					g_strfreev(cmd);
 					g_free(cmd_text);
 
@@ -314,5 +235,5 @@
 			/* If we reached the end of the buffer, there's still an incomplete command there.
 			   Return and wait for more data. */
-			if (i == h->rxlen && h->rxq[i - 1] != '\r' && h->rxq[i - 1] != '\n') {
+			if (i && i == h->rxlen && h->rxq[i - 1] != '\r' && h->rxq[i - 1] != '\n') {
 				break;
 			}
@@ -327,10 +248,11 @@
 
 			msg = g_strndup(h->rxq, h->msglen);
-			cmd = msn_linesplit(h->cmd_text);
-			for (count = 0; cmd[count]; count++) {
-				;
-			}
-
-			st = h->exec_message(h, msg, h->msglen, cmd, count);
+
+			cmd = g_strsplit_set(h->cmd_text, " ", -1);
+			count = g_strv_length(cmd);
+
+			st = msn_ns_message(h, msg, h->msglen, cmd, count);
+
+			g_strfreev(cmd);
 			g_free(msg);
 			g_free(h->cmd_text);
@@ -366,44 +288,4 @@
 }
 
-void msn_msgq_purge(struct im_connection *ic, GSList **list)
-{
-	struct msn_message *m;
-	GString *ret;
-	GSList *l;
-	int n = 0;
-
-	l = *list;
-	if (l == NULL) {
-		return;
-	}
-
-	m = l->data;
-	ret = g_string_sized_new(1024);
-	g_string_printf(ret, "Warning: Cleaning up MSN (switchboard) connection with unsent "
-	                "messages to %s:", m->who ? m->who : "unknown recipient");
-
-	while (l) {
-		m = l->data;
-
-		if (strncmp(m->text, "\r\r\r", 3) != 0) {
-			g_string_append_printf(ret, "\n%s", m->text);
-			n++;
-		}
-
-		g_free(m->who);
-		g_free(m->text);
-		g_free(m);
-
-		l = l->next;
-	}
-	g_slist_free(*list);
-	*list = NULL;
-
-	if (n > 0) {
-		imcb_log(ic, "%s", ret->str);
-	}
-	g_string_free(ret, TRUE);
-}
-
 /* Copied and heavily modified from http://tmsnc.sourceforge.net/chl.c */
 char *msn_p11_challenge(char *challenge)
@@ -529,13 +411,6 @@
 int msn_ns_set_display_name(struct im_connection *ic, const char *value)
 {
-	struct msn_data *md = ic->proto_data;
-	char fn[strlen(value) * 3 + 1];
-
-	strcpy(fn, value);
-	http_encode(fn);
-
-	/* Note: We don't actually know if the server accepted the new name,
-	   and won't give proper feedback yet if it doesn't. */
-	return msn_ns_write(ic, -1, "PRP %d MFN %s\r\n", ++md->trId, fn);
+	// TODO, implement this through msn_set_away's method
+	return 1;
 }
 
